# Edited by rpmlb
%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

# Generated from activerecord-1.15.5.gem by gem2rpm -*- rpm-spec -*-
%global gem_name activerecord

Summary: Object-relational mapper framework (part of Rails)
Name: %{?scl_prefix}rubygem-%{gem_name}
Epoch: 1
Version: 5.0.1
Release: 4%{?dist}
Group: Development/Languages
License: MIT
URL: http://rubyonrails.org
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
# git clone http://github.com/rails/rails.git
# cd rails/activerecord/
# git checkout v5.0.1 && tar czvf activerecord-5.0.1-tests.tgz test/
Source1: activerecord-%{version}-tests.tgz

# Fixnum and Bignum are deprecated in Ruby trunk
# https://github.com/rails/rails/pull/26732
Patch0: rubygem-activerecord-5.0.1-Fixnum-and-Bignum-are-deprecated-in-Ruby-trunk.patch

# Fix unstable ReflectionTest#test_read_attribute_names test.
# https://github.com/rails/rails/pull/26124
Patch1: activerecord-5.0.1-Creating-a-new-Topic-class-instead-of-class_eval.patch

Requires: %{?scl_prefix_ruby}ruby(release)
Requires: %{?scl_prefix_ruby}ruby(rubygems)
Requires: %{?scl_prefix}rubygem(activemodel) = %{version}
Requires: %{?scl_prefix}rubygem(activesupport) = %{version}
Requires: %{?scl_prefix}rubygem(arel) >= 7.0.0
Requires: %{?scl_prefix}rubygem(arel) < 8.0.0
BuildRequires: %{?scl_prefix_ruby}rubygems-devel
BuildRequires: %{?scl_prefix}rubygem(bcrypt)
BuildRequires: %{?scl_prefix}rubygem(activesupport) = %{version}
BuildRequires: %{?scl_prefix}rubygem(activemodel)   = %{version}
BuildRequires: %{?scl_prefix}rubygem(builder)
BuildRequires: %{?scl_prefix}rubygem(sqlite3)
BuildRequires: %{?scl_prefix}rubygem(erubis)
BuildRequires: %{?scl_prefix}rubygem(mocha)
BuildRequires: %{?scl_prefix}rubygem(arel) >= 7.0.0
BuildRequires: %{?scl_prefix}rubygem(arel) < 8.0.0
BuildRequires: %{?scl_prefix_ruby}rubygem(minitest)
BuildRequires: %{?scl_prefix}rubygem(rack)
%{!?scl:BuildRequires: %{_bindir}/sqlite3}
BuildArch: noarch
Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}

# Explicitly require runtime subpackage, as long as older scl-utils do not generate it
%{?scl:Requires: %{?scl_prefix}runtime}

%description
Implements the ActiveRecord pattern (Fowler, PoEAA) for ORM. It ties database
tables and classes together for business objects, like Customer or
Subscription, that can find, save, and destroy themselves without resorting to
manual SQL.

%package doc
Summary: Documentation for %{pkg_name}.
Group: Documentation
Requires: %{?scl_prefix}%{pkg_name} = %{epoch}:%{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{pkg_name}

%prep
%{?scl:scl enable %{scl} - << \EOF}
set -e
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:EOF}

%build
%{?scl:scl enable %{scl} - << \EOF}
set -e
gem build %{gem_name}.gemspec
%gem_install
%{?scl:EOF}

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}

tar xzvf %{SOURCE1}

patch -p2 < %{PATCH0}
patch -p2 < %{PATCH1}

# Disable unstable tests.
# https://github.com/rails/rails/issues/25774
sed -i '/^  def test_preconfigured_includes_with_has_many_and_habtm$/,/^  end$/ s/^/#/' \
  test/cases/associations/eager_test.rb
sed -i '/^  def test_has_one_through_polymorphic_with_primary_key_option$/,/^  end$/ s/^/#/' \
  test/cases/associations/has_one_through_associations_test.rb
sed -i '/^  def test_has_many_through_polymorphic_with_primary_key_option$/,/^  end$/ s/^/#/' \
  test/cases/associations/has_many_through_associations_test.rb
sed -i '/^  def test_create_resets_cached_counters$/,/^  end$/ s/^/#/' \
  test/cases/associations/has_many_associations_test.rb
sed -i '/^  def test_do_not_call_callbacks_for_delete_all$/,/^  end$/ s/^/#/' \
  test/cases/associations/has_many_associations_test.rb
sed -i '/^  def test_find_queries_with_cache_multi_record$/,/^  end$/ s/^/#/' \
  test/cases/associations/has_many_associations_test.rb
sed -i '/^      def test_add_column_with_timestamp_type$/,/^      end$/ s/^/#/' \
  test/cases/migration/change_schema_test.rb
sed -i '/^  def test_do_not_call_callbacks_for_delete_all$/,/^  end$/ s/^/#/' \
  test/cases/query_cache_test.rb
sed -i '/^    def test_raises_an_error_when_called_with_protected_environment$/,/^    end$/ s/^/#/' \
  test/cases/tasks/database_tasks_test.rb
sed -i '/^class FoxyFixturesTest < ActiveRecord::TestCase/,/^end$/ s/^/#/' \
  test/cases/fixtures_test.rb

%{?scl:scl enable %{scl} - << \EOF}
ruby -Itest:lib <<EOR
  test_files = Dir.glob( "./test/cases/**/*_test.rb" )
  test_files.reject! { |x| x =~ %r|/adapters/| }

  # Only test sqlite3 backend
  test_files += Dir.glob("./test/cases/adapters/sqlite3/*_test.rb")

  test_files.sort.each { |f| require f }
EOR
%{?scl:EOF}

popd

%files
# There is no %%license macro on RHEL6.
# https://bugzilla.redhat.com/show_bug.cgi?id=1386246
%{!?_licensedir:%global license %%doc}

%dir %{gem_instdir}
%{gem_libdir}
%license %{gem_instdir}/MIT-LICENSE
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/README.rdoc
%{gem_instdir}/examples

%changelog
* Fri Feb 03 2017 Jun Aruga <jaruga@redhat.com> - 1:5.0.1-4
- Fix unstable ReflectionTest#test_read_attribute_names test.

* Thu Jan 12 2017 Jun Aruga <jaruga@redhat.com> - 1:5.0.1-3
- Update to Active Record 5.0.1.
- Fix warnings: Fixnum and Bignum are deprecated in Ruby trunk

* Wed Aug 17 2016 Jun Aruga <jaruga@redhat.com> - 1:4.2.6-3
- Fix for CVE-2016-6317
  Resolves: rhbz#1365017
- Improve tests not to accept the failures

* Fri Apr 08 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.6-2
- Make build fail on tests failure
- Lower accepted test failures to 2

* Mon Apr 04 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.6-1
- Update to 4.2.6

* Wed Feb 17 2016 Pavel Valena <pvalena@redhat.com> - 1:4.2.5.1-3
- Update to 4.2.5.1

* Wed Feb 10 2016 Pavel Valena <pvalena@redhat.com> - 1:4.1.5-2
- Fix possible input validation circumvention - rhbz#1301973
  - Resolves: CVE-2016-0753
- Nested attributes rejection proc bypass - rhbz#1301957
  - Resolves: CVE-2015-7577

* Thu Jan 22 2015 Josef Stribny <jstribny@redhat.com> - 1:4.1.5-1
- Update to 4.1.5

* Fri Aug 22 2014 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-5
- Fix CVE-2014-3514: vulnerability in the create_with
  - Resolves: rhbz#1133531

* Wed Jul 09 2014 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-4
- Fix CVE-2014-3483 regression
  - Related: rhbz#1115336

* Thu Jul 03 2014 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-3
- Fix CVE-2014-3483
  - Resolves: rhbz#1115336

* Tue Feb 18 2014 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-2
- Fix CVE-2014-0080: PostgreSQL array data injection vulnerability
  - Resolves: rhbz#1065585

* Wed Dec 04 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.2-1
- Update to ActiveRecord 4.0.2
  - Resolves: rhbz#1037985

* Thu Nov 21 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.1-1
- Update to ActiveRecord 4.0.1

* Mon Oct 14 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.0-2
- Convert to scl

* Thu Aug 01 2013 Josef Stribny <jstribny@redhat.com> - 1:4.0.0-1
- Update to ActiveRecord 4.0.0.

* Tue Mar 19 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.13-1
- Update to ActiveRecord 3.2.13.

* Mon Mar 04 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.12-2
- Rebuild for https://fedoraproject.org/wiki/Features/Ruby_2.0.0

* Tue Feb 12 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.12-1
- Update to ActiveRecord 3.2.12.

* Wed Jan 09 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.11-1
- Update to ActiveRecord 3.2.11.

* Thu Jan 03 2013 Vít Ondruch <vondruch@redhat.com> - 1:3.2.10-1
- Update to ActiveRecord 3.2.10.

* Mon Aug 13 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.2.8-1
- Update to ActiveRecord 3.2.8.

* Mon Jul 30 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.2.7-1
- Update to ActiveRecord 3.2.7.

* Tue Jul 24 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.2.6-2
- Fixed missing epoch in -doc subpackage.

* Thu Jul 19 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.2.6-1
- Update to ActiveRecord 3.2.6.

* Fri Jun 15 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.15-1
- Update to ActiveRecord 3.0.15.

* Fri Jun 01 2012 Vít Ondruch <vondruch@redhat.com> - 1:3.0.13-1
- Update to ActiveRecord 3.0.13.

* Tue Jan 31 2012 Bohuslav Kabrda <bkabrda@redhat.com> - 1:3.0.11-1
- Rebuilt for Ruby 1.9.3.
- Update to ActionRecord 3.0.11

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:3.0.10-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Mon Aug 22 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.10-1
- Update to ActiveRecord 3.0.10

* Mon Jul 04 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.9-1
- Update to ActiveRecord 3.0.9

* Fri Mar 25 2011 Vít Ondruch <vondruch@redhat.com> - 1:3.0.5-1
- Updated to ActiveRecord 3.0.5

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:3.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 10 2011 Mohammed Morsi <mmorsi@redhat.com> - 1:3.0.3-1
- Update to rails 3

* Wed Sep 08 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-4
- Updated postgres fix to resolve security issue

* Mon Aug 16 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-3
- Included postgres fix (patch also pushed upstream, see rails issue tracker)

* Thu Aug 12 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-2
- Updated patch0 to correctly parse sqlite3 version

* Wed Aug 04 2010 Mohammed Morsi <mmorsi@redhat.com> - 1:2.3.8-1
- Update to 2.3.8

* Thu Jan 28 2010 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 1:2.3.5-1
- Update to 2.3.5

* Wed Oct  7 2009 David Lutterkort <lutter@redhat.com> - 1:2.3.4-2
- Bump Epoch to ensure upgrade path from F-11

* Fri Sep 18 2009 Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 2.3.4-1
- Update to 2.3.4
- Enable check

* Sun Jul 26 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.3.3-1
- New upstream version

* Mon Mar 16 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.3.2-1
- New upstream version

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Nov 24 2008 Jeroen van Meeuwen <kanarip@fedoraproject.org> - 2.2.2-1
- New upstream version
- Fixed rpmlint errors zero-length files and script-without-shebang

* Thu Nov 20 2008 David Lutterkort <lutter@redhat.com> - 2.1.1-2
- Do not mark lib/ as doc

* Tue Sep 16 2008 David Lutterkort <dlutter@redhat.com> - 2.1.1-1
- New version (fixes CVE-2008-4094)

* Thu Jul 31 2008 Michael Stahnke <stahnma@fedoraproject.org> - 2.1.0-1
- New Upstream

* Tue Apr  8 2008 David Lutterkort <dlutter@redhat.com> - 2.0.2-2
- Fix dependency

* Mon Apr 07 2008 David Lutterkort <dlutter@redhat.com> - 2.0.2-1
- New version

* Mon Dec 10 2007 David Lutterkort <dlutter@redhat.com> - 2.0.1-1
- New version

* Thu Nov 29 2007 David Lutterkort <dlutter@redhat.com> - 1.15.6-1
- New version

* Tue Nov 14 2007 David Lutterkort <dlutter@redhat.com> - 1.15.5-2
- Fix buildroot
- Properly mark docs in geminstdir

* Tue Oct 30 2007 David Lutterkort <dlutter@redhat.com> - 1.15.5-1
- Initial package
